love.graphics.setDefaultFilter('nearest', 'nearest')

player = {x = 60, y = 0, width = 20, height = 20, speed = 100}
box = {x = 60, y = 60, width = 20, height = 20}

--check if entity 1's bounding box intersects with entity 2's bounding box
function broadCollision(e1, e2)
	if e1.x < e2.x + e2.width and
		e2.x < e1.x + e1.width and
		e1.y < e2.y + e2.height and
		e2.y < e1.y + e1.height then
			return true
	else
		return false
	end
end

--check if entity 1 collides with entity 2 along the x axis
function xCollision(e1, e2)
	if e1.x < e2.x + e2.width and e2.x < e1.x + e1.width then
		return true
	else
		return false
	end
end

--check if entity 1 collides with entity 2 along the y axis
function yCollision(e1, e2)
	if e1.y < e2.y + e2.height and e2.y < e1.y + e1.height then
		return true
	else
		return false
	end
end

function love.keypressed(key)
	if key == 'escape' then
		love.event.quit()
	end
end

function love.load()

end

function love.update(dt)
	--store player's previous x and y positions
	px = player.x
	py = player.y
	
	vx = 0
	vy = 0
	
	--player movement
	if love.keyboard.isDown('left') then
		vx = -player.speed
	end
	if love.keyboard.isDown('right') then
		vx = player.speed
	end
	if love.keyboard.isDown('up') then
		vy = -player.speed
	end
	if love.keyboard.isDown('down') then
		vy = player.speed
	end
	
	--ignore the following 5 chunks of code, it's just code to fix the arrow keys favoring down and right
	if love.keyboard.isDown('left') and
		love.keyboard.isDown('up') and
		love.keyboard.isDown('down') then
			vx = vx
			vy = 0
	end
	
	if love.keyboard.isDown('right') and
		love.keyboard.isDown('up') and
		love.keyboard.isDown('down') then
			vx = vx
			vy = 0
	end
	
	if love.keyboard.isDown('left') and
		love.keyboard.isDown('right') and
		love.keyboard.isDown('up') then
			vx = 0
			vy = vy
	end
	
	if love.keyboard.isDown('left') and
		love.keyboard.isDown('right') and
		love.keyboard.isDown('down') then
			vx = 0
			vy = vy
	end
	
	if love.keyboard.isDown('left') and
		love.keyboard.isDown('right') and
		love.keyboard.isDown('up') and
		love.keyboard.isDown('down') then
			vx = 0
			vy = 0
	end
	
	--apply x and y velocities to player
	player.x = player.x + vx * dt
	player.y = player.y + vy * dt
	
	--aabb collision
	if broadCollision(player, box) then
		--x axis collision
		if xCollision(player, box) then
			--a collision happened on the x axis, reset player's x position to his previous x position
			player.x = px
			
			if yCollision(player, box) then
				--a collision happened on the y axis, reset player's y position to his previous y position
				player.y = py
			end
		else
			--a collision has only happened on the y axis, reset player's y position to his previous y position
			player.y = py
		end
	end
end

function love.draw()
	love.graphics.scale(2, 2)

	love.graphics.setColor(255, 255, 255)
	love.graphics.rectangle('line', player.x, player.y, player.width, player.height)
	
	love.graphics.setColor(255, 255, 255)
	love.graphics.rectangle('line', box.x, box.y, box.width, box.height)
end

